Bug 97786 - (SCSI AIC79XX)File corruption upon a simple copy. aic79xx
(SCSI AIC79XX)File corruption upon a simple copy. aic79xx
Status: CLOSED WONTFIX
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
8.0
i686 Linux
medium Severity high
: ---
: ---
Assigned To: Arjan van de Ven
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2003-06-20 21:32 EDT by Need Real Name
Modified: 2007-04-18 12:54 EDT (History)
1 user (show)

See Also:
Fixed In Version: 73733
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-30 11:41:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Need Real Name 2003-06-20 21:32:58 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.0.1) Gecko/20021003

Description of problem:
Problem: Copying large files (>500Mb) results in file corruption of at least
half the files. Tested on 3 of the new PC's. All failed. Tests and results were
observed by several engineers and is reproducible.  This problem prevents us
from installing Oracle, handling large files and performing other necessary tasks.

Hardware:
IBM Intellistation M Pro
Intel Pentium 4 2.66Mhz, 1Gb RAM
Adaptec (on motherboard) U320 SCSI (SCSI bios 4.10) with two IBM 75Gb SCSI
drives, dual boot Win2k/Red Hat 8.0
Boot message: aic7902: Ultra320 WideChannel A, SCSI Id=7, PCI 33 or 66Mhz, 512 SCBs
NVidia Quadro Pro with dual head digital flat panels

Investigation:
1) Checked hard drive firmware:
http://www-1.ibm.com/support/docview.wss?uid=psg1MIGR-4GSU4F
Downloaded CD ISO (73p6458.iso): Hard Drive Update program for IBM
Intellistation and Servers
Burned CD and booted from CD. This program informed me that the IBM hard drives
are using the latest firmware thus no update is needed.

2) Installed latest Red Hat kernel RPM's:
kernel-2.4.20-18.8.i686.rpm
Also tried kernel-smp-2.4.20-18.8.i686.rpm
kernel-source-2.4.20-18.8.i386.rpm
Ran NVidia driver installer: NVIDIA-Linux-x86-1.0-4363.run
Rebooted. It uses Adaptec U320 driver 1.0.0
Tried file copy, corruption still a problem.

4) Installed the latest Adaptec driver from
http://linux.adaptec.com/Linux_drivers.html
aic79xx-1.1.0-rh80.i686.rpm

List of pre-built drivers shows that the latest Adaptec RPMs do NOT support the
latest Red Hat releases.

tar tzf /usr/adaptec/aic79xx/aic79xx_prebuilt.tgz
aic79xx-2.4.18-14-athlon
aic79xx-2.4.18-14bigmem-i686
aic79xx-2.4.18-14-i386
aic79xx-2.4.18-14-i686
aic79xx-2.4.18-14smp-athlon
aic79xx-2.4.18-14smp-i386
aic79xx-2.4.18-14smp-i686
base

Thus backed out new kernels and installed:
kernel-2.4.18-14.i686.rpm
kernel-source-2.4.18-14.i386.rpm
Also tried the smp kernel but it would not boot the system.
Rebooted with kernel-2.4.18-14

Installed the Adaptec RPM then ran the NVidia installer:
NVIDIA-Linux-x86-1.0-4363.run
Rebooted and the system and saw "Adaptec AIC79XX PCI-X SCSI HBA DRIVER, Rev
1.1.0", the latest SCSI driver.
Tests with file copies results in file corruption. Worst corruption percentage yet.

5) Booted this dual boot system to Win2k and copied many large files, no
corruption problems. Used Cygwin md5sum for file

comparison.
From this I assume that the hardware is ok.

6) Ran tests on Compaq 600Mhz IDE based system with kernel 2.4.18-19.8.0. No
problems. Thus it is probably not a problem with the Linux Kernel.

7) Currently running newest Red Hat kernel 2.4.20-18.8 and the Adaptec 1.0.0
driver (comes with Red Hat RPM) with options in /etc/modules.conf options
aic79xx periodic_otag,reverse_scan,versbose and tried debug option ffff but got
no messages.

I get kernel message (/var/log/messages):
Jun 19 18:48:24 DECAV68462 kernel: (scsi0:A:2:0): Locking max tag count at 128
 
------------------------------------------------------------

Example of file corruption:
Original files:
ls -l
-rw-r--r--    1 ipp      user     553239173 Jun 16 15:38 lnx_920_disk1.cpio.gz
-rw-r--r--    1 ipp      user     588798999 Jun 16 19:01 lnx_920_disk2.cpio.gz
-rw-r--r--    1 ipp      user     442087410 Jun 16 18:25 lnx_920_disk3.cpio.gz

md5sum *
63fa68e20ee622b6ac7b8593da93b99f  lnx_920_disk1.cpio.gz
f0faf75ff257c642b8407b9049459cf4  lnx_920_disk2.cpio.gz
0b8ded908ab1fad1c363a5d3f7873d0d  lnx_920_disk3.cpio.gz

Copied to a new directory:
files same size.
baaf6f76e9f07ff8b18effe6be34757d  lnx_920_disk1.cpio.gz
c917c4596b9a3ebe8b23fd2dbe0dd1d2  lnx_920_disk2.cpio.gz
0b8ded908ab1fad1c363a5d3f7873d0d  lnx_920_disk3.cpio.gz

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1.copy large files >500Mb from one directory to another.
2.
3.
    

Actual Results:  file corruption:
Original files:
ls -l
-rw-r--r--    1 ipp      user     553239173 Jun 16 15:38 lnx_920_disk1.cpio.gz
-rw-r--r--    1 ipp      user     588798999 Jun 16 19:01 lnx_920_disk2.cpio.gz
-rw-r--r--    1 ipp      user     442087410 Jun 16 18:25 lnx_920_disk3.cpio.gz

md5sum *
63fa68e20ee622b6ac7b8593da93b99f  lnx_920_disk1.cpio.gz
f0faf75ff257c642b8407b9049459cf4  lnx_920_disk2.cpio.gz
0b8ded908ab1fad1c363a5d3f7873d0d  lnx_920_disk3.cpio.gz

Copied to a new directory:
files same size.
baaf6f76e9f07ff8b18effe6be34757d  lnx_920_disk1.cpio.gz
c917c4596b9a3ebe8b23fd2dbe0dd1d2  lnx_920_disk2.cpio.gz
0b8ded908ab1fad1c363a5d3f7873d0d  lnx_920_disk3.cpio.gz

Expected Results:  No corruption for files. md5sum should remain the same.

Additional info:
Comment 1 James Turnbull 2003-06-22 13:13:08 EDT
According to:
https://rhn.redhat.com/errata/RHSA-2003-187.html
This is the latest Redhat 8.0 kernel release:
kernel-2.4.20-18.8.i686.rpm
(June 3)
This is the one Greg is having problems with (see above, under "2")

Am I missing something?
Comment 2 Need Real Name 2003-06-23 14:56:02 EDT
If I load stock Red Hat RPM without NVidia mods and boot to init level 3 (no 
graphics) the problem remains. It is NOT related to the NVidia mods.
Comment 3 Alan Cox 2003-06-27 16:54:14 EDT
Almost certainly needs the new aic79xx driver.

Comment 4 Need Real Name 2003-06-27 21:38:44 EDT
Found the fix!!!!! Red Hat 8.0 kernels use Adaptec SCSI driver 1.0.0. The
drivers available for download from Adaptec are version 1.1.0 (also bad). Use
version 1.3 for Adaptec aic79xx.

http://people.freebsd.org/~gibbs/linux/RPM/aic79xx/aic79xx-1.3.10-rh80.i686.rpm

Source code:
http://people.freebsd.org/~gibbs/linux/SRC/aic79xx-linux-2.4-20030603-tar.gz 

Red Hat please issue a new kernel RPMs with these new drivers as this is a sly
data corruption issue for modern computers with Adaptec SCSI.

Thanks to Justin Gibbs for issueing these new drivers.
Greg
Comment 5 Bugzilla owner 2004-09-30 11:41:10 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.